﻿namespace SvdCli.Storage
{
    public interface IStorage
    {
        string ProductId { get; }
        string ProductVersion { get; }

        uint BlockSize { get; }
        ulong BlockCount { get; }
        uint MaxTransferLength { get; }

        bool SupportTrim { get; }
        bool WriteProtect { get; }

        void Init();

        void Exit();

        void Read(byte[] buffer, ulong blockIndex, uint blockCount);

        void Write(byte[] buffer, ulong blockIndex, uint blockCount);

        void Flush();

        void Trim(params TrimDescriptor[] descriptors);
    }
}
